


void err_sbm_window(int err)
{
        lcd_gotoxy(0,0);sprintf(Str_LCD,"  %1u !",err);
        lcd_puts(Str_LCD);
        lcd_gotoxy(0,1); sprintf(Str_LCD,"  ?");  
	    lcd_puts(Str_LCD);
}


unsigned int zivert_convert0(unsigned int x)
{        
	unsigned int tmp, retr=0;
	tmp=x;

        while(tmp>=100){retr++; tmp-=100; }     //  

        return retr;
}

unsigned int zivert_convert1(unsigned int x)
{        
        unsigned int tmp, retr=0;
	tmp=x;

        while(tmp>=100){retr++; tmp-=100; }     //  
        tmp=retr*100;
        return (x-tmp);
}


void Start_adc_conversion(void)
{       unsigned int  tmpv=0;
        unsigned char ixi=16;

        #asm("sei");         //   
        {ADMUX= 0b11000111;} // ADC7
 
		
	ADCSRA=0b10011101; 
        MCUCR=0x90;	  //    
        delay_us(125);

        while(ixi>0)
        {#asm("sleep");    //   
	 tmpv+=VoltLevel;                   
         ixi--;
        }
	
        MCUCR=MCUCR_def;       //   .
        ADCSRA=0x00; 
	    ACSR=0x00; 
	    ADMUX=0x00;   //       

        VoltLevel=(tmpv>>4);
}

void bat_load(void)
{
	unsigned char number_char;
	byte i; 
	byte command_addr;
        #pragma warn-
	for (number_char=0; number_char<7; number_char++)
	{
		command_addr=(number_char*8)+0b01000000;
		for (i=0; i<8; i++)
		{
			lcd_write_byte(command_addr++,bat_chars[(number_char*8)+i]);
		}
	}
        #pragma warn+
}

//---------------------------------------- ---------------------------------
unsigned int volt_conv()
{               
	unsigned int  tmpv;

        {tmpv=((VoltLevel*div_voltage)/4);}    //        2 560 /1023 = 2,5 /.
        return tmpv;
}


//----------------------------------------- --------------------------------
void my_beep(void) 
{    
 // if(Sound_bit)
  // {
        beep = 1;
        delay_ms(30);
        beep = 0;
 //  }   
}


void my_beep_delay_350(void) 
{    
 // if(Sound_bit)
 //  {
        my_beep();
        delay_ms(350);
 //  }
}



//------------------------------------------------------------------------



void Get_light(void) 
{    
	if(!key5)
    {
        delay_ms(100); 
        butt_light++;
    } else
    { butt_light=0;}                                                 //    

	if((((butt_light==5))|((butt_light==10)))&(!key_lock)) 
    {  
      //  Sound_bit = 0; //   
        bit_fL++; 
        delay_ms(450);
        power_led=1;    
        beep = 1;
        delay_ms(30); 
        power_led=0;
        beep = 0;
        flash_light=bit_fL;
        delay_ms(450);
       // Sound_bit = Sound_bitEeprom;     //  
    }                 // / 
	if(butt_light>  11)
    {   
       // Sound_bit = 0; //   
        delay_ms(450);
        power_led=1;    
        beep = 1;
        delay_ms(30); 
        power_led=0;
        beep = 0;
        delay_ms(100);
        power_led=1;
        beep = 1;     
        delay_ms(30); 
        power_led=0;
        beep = 0;
        butt_light=0;
        key_lock++; 
        delay_ms(450);  
       // Sound_bit = Sound_bitEeprom;     //  
    } // /  
}

//----------------------------------------     

void Get_Warn(void)         
{
	if((Alarm_is_On)&(AlarmMode))    // 
	{   
    Sound_bit = 0; //   
        	if((!key1)|(!key2)|(!key3)|(!key4)|(!key5))
		{       
		        Alarm_is_On=0; 
		        AlarmTime=0; 
		        beep = 0;  
		        flash_light = bit_fL; 
                Sound_bit = Sound_bitEeprom;     //  
                        delay_ms(30);
		        my_beep_delay_350();
			return;                    //  
        } 

        if(tick_timer2>15)
        {   
            beep=1;                    //  
		    light = 1;                 //  
        }
        else
        {
        	beep=0;                    //  
		    light = 0;                 //       
        }
                
		if(AlarmTime > 20)    //  20 
		{
			beep = 0; 
			light = bit_L;              // 
			AlarmTime=0;                // 
			Alarm_is_On=0;              // 
            Sound_bit = Sound_bitEeprom;     //  
		}
	}
}


//--------------------------------------------- ------------------------------------
void my_keys(void)
{                     
	if((!key1)&(!key_lock)){ok=1;}else{ok=0;}    // ok     
	if((!key4)&(!key_lock)){x=1;}else{ x=0;}     // x        

        if((!key3)&(!key_lock)){ Menu=m1[im1]; im1++; im2--; my_beep(); while(!key3){} delay_ms(100);   setup_menu=0; }   //   > 
       	if(im1>3){im1=0;}
        
        if(setup_menu)
        {
        	if((!key2)&(!key_lock)){Menu=m3[im2]; im2++; im1--; my_beep(); while(!key2){} delay_ms(100); }   //   <
        	if(im2>2){im2=0;}

        }
        else
        {
        	if((!key2)&(!key_lock)){Menu=m2[im2]; im2++; im1--; my_beep(); while(!key2){} delay_ms(100); }   //   <
        	if(im2>4){im2=0;}
        }
}


//---------------------------------------------------------------------------------
/*
void Usart (void)
{
        unsigned char IndexHi;                //    
        unsigned char IndexLo;                //     
        unsigned char voltIndexHi;                //    
        unsigned char voltIndexLo;                //     
        unsigned char crc;                //  
	unsigned int  Volt;

	if((TX_PC_Bit)&(Tx_bit))
	{                         
		Volt=volt_conv();
		crc=((m_buffer+Volt) & 0xff);			    //  
		UCSRB=0x08;                                         // 8 1
		UCSRC=0x86;
		UBRRH=0x03;                                         //   600 
		UBRRL=0x40;                                         //  
		delay_ms(100);   

		IndexLo =  m_buffer & 0xff;                         //     
		IndexHi = (m_buffer >> 8) & 0xff;                   //       

		voltIndexLo =  Volt & 0xff;                         //     
		voltIndexHi = (Volt >> 8) & 0xff;                   //       
	
		putchar(0xE9);                                      //   3
		putchar(IndexHi);                                   //    
		putchar(IndexLo);                                   //    

		putchar(0xE5);                                      //   
		putchar(voltIndexHi);                               //    
		putchar(voltIndexLo);                               //    
		putchar(crc);                                       //   
		putchar(0xA4);                                      //    
	
		delay_ms(100);                                     //
		UCSRB=0x00;                                       // 
		UCSRC=0x00;
		UBRRH=0x00;
		UBRRL=0x00; 
		TX_PC_Bit =0; 				//    
	}           
}
*/
void calculate_battarey(void)  //   
{
unsigned int tmpvx,tmpvx_procent;
unsigned char div_x; 
Start_adc_conversion();
bat_level=0x00;
tmpvx=volt_conv();
tmpvx_procent=(tmpvx-Low_battery_voltage)/((High_battery_voltage-Low_battery_voltage)/100);
if(Low_battery_voltage>tmpvx){tmpvx_procent=0;}
if(High_battery_voltage<tmpvx){tmpvx_procent=100;}
        
div_x=tmpvx_procent/15;
while(div_x--)bat_level++;

if(Low_battery_voltage>tmpvx)
{       
     //   tmp=Sound_bit;
	for(div_x=0;div_x<6;div_x++)
        {
                my_beep();
	        delay_ms(60);
        }
	//Sound_bit = tmp;
}


}

//---------------------------------------------------------------------------------------------------
void calculate_counters(void)
{unsigned int xi1;

    if(rf>10000){rf=0;}                      // ,    
    if(j>18){ rf++; j=0;}                    //   


	if(sec>(TimeCount-1))              //    ( (s>(t-1))           
    
    
	{ 	
    



    if((k > warn)&(AlarmMode)){Alarm_is_On =1;AlarmTime=0;Menu=2;}      //        
  	if(k>maximum_fon){maximum_fon=k;}
        

         if (sbm_norm==1)
         {
                if (geiger1==0){sbm_error_count_1++;}
                else
                {sbm_error_count_1=0;}
                        
                if (geiger2==0){sbm_error_count_2++;}
                else
                {sbm_error_count_2=0;}
                
             if(sbm_error_count_1>5)
             {
              Ce=0;err=1;err_sbm_window(1);while(err)
              {
                disp_min=0;
                my_beep();
                delay_ms(500);
              
              if(!key1)        //   -------------------------------------------------------------
		      {   
                TimeCount = LoadTimeFail;
			    k=0; rf=0; j=0; sec=0;
			    Ce=1;
                err=0;                            //  
			    my_beep_delay_350();
                sbm_norm=0;
		      }
             }      
            }
                
            if(sbm_error_count_2>5)
            {
              Ce=0;err=1;err_sbm_window(2);while(err)
              {
                disp_min=0;
                my_beep();
                delay_ms(300);
                my_beep();
                delay_ms(500);
                              
              if(!key1)        //   -------------------------------------------------------------
		      {   
                TimeCount = LoadTimeFail;
			    k=0; rf=0; j=0; sec=0;
			    Ce=1;
                err=0;                            //  
			    my_beep_delay_350();
                sbm_norm=0;
		      }
             }  
            }   
          }

	/*	if(AutoGen_bit)                    //   ,     .
		{	HV_Pump=1;               //   ,  
			ecco=0;
			HV_Pump_st=1;         
		} */    
        
        geiger1=0;                               //     (    )
        geiger2=0;                               //     (    )
		m_buffer = k;                            //      
//		TX_PC_Bit = 1;                           //    
                
                // ---------------   ,     3                 
                if(((m_buffer>(ts2*3))|((ts2>(m_buffer*3))))&(m_buffer>50))
                {
                 for (xi1=0; xi1<20; xi1++)tm[xi1]=0; //   
                 tp=80;                               //  
                 ti=0;                                //   
                 ti2=0;                               //   2 
                }
                
                //--------------------------- ---""-----------//  
		tm[ti]=k; ti++; ti2++;                //     
		if(ti>19){ti=0;}                      //  
		if(tp>20){tp--;}else{};               //  
		ts1=0;
		for (xi1=0; xi1<20; xi1++)
		{ts1+=tm[xi1];}                       //  
		if(ti2<19){ts2=ts1/ti; }              //     1  
		   else                               // 
		{ts2=ts1/19; }                        //     2   
		if(ti2>254){ti2=90;}                  //  
		if(ed_ok){ed_mass[numm]=k; numm++;}   //     
		sec=0; k=0; j=0; rf_last=rf; rf=0;    //  
		Ce=1;                                 //              
	calculate_battarey();              //   
    }

}